/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * OCL Compiler                                                      *
 * Copyright (C) 2005, 2006 Ronny Brandt (Ronny_Brandt@gmx.de).      *
 * All rights reserved.                                              *
 *                                                                   *
 * This work was done as a diploma project at the Chair for Software *
 * Technology, Dresden University Of Technology, Germany             *
 * (http://www-st.inf.tu-dresden.de).  It is understood that any     *
 * modification not identified as such is not covered by the         *
 * preceding statement.                                              *
 *                                                                   *
 * This work is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU Library General Public       *
 * License as published by the Free Software Foundation; either      *
 * version 2 of the License, or (at your option) any later version.  *
 *                                                                   *
 * This work is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *
 * Library General Public License for more details.                  *
 *                                                                   *
 * You should have received a copy of the GNU Library General Public *
 * License along with this library; if not, write to the             *
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,      *
 * Boston, MA  02111-1307, USA.                                      *
 *                                                                   *
 * To submit a bug report, send a comment, or get the latest news on *
 * this project and other projects, please visit the web site:       *
 * http://www-st.inf.tu-dresden.de/ (Chair home page) or             *
 * http://www-st.inf.tu-dresden.de/ocl/ (project home page)          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
package tudresden.ocl20.core.lib;
import java.util.*;

public abstract class OclSortedCollection extends OclCollection {
	
	protected OclSortedCollection(Collection c){
		super(c);
	}
	
	/** constructor for undefined OCL collection
	  */
	protected OclSortedCollection(int dummy, String reason){
		super(dummy, reason);
	}
	
	/**
	 * The OCL types Sequence and OrderedSet have this operation definded
	 * @param index The index of the element
	 * @return The element at position <code>index</code> of the collection
	 */
	public abstract OclRoot at(OclInteger index);
	
	/**
	 * The OCL types Sequence and OrderedSet have this operation definded
	 * @return The first element of the collection
	 */
	public abstract OclRoot first();
	
	/**
	 * The OCL types Sequence and OrderedSet have this operation definded
	 * @return The last element of the collection
	 */
	public abstract OclRoot last();
	
	/**
	 * The OCL types Sequence and OrderedSet have this operation definded
	 * @param obj 
	 * @return The position of the Object <code>obj</code> in the collection
	 */
	public abstract OclInteger indexOf(OclRoot obj);
	
	public abstract OclSortedCollection insertAt(OclInteger index, OclRoot obj);
	
	public abstract OclSortedCollection append(OclRoot obj);
	
	public abstract OclSortedCollection prepend(OclRoot obj);

}
