/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
 * OCL Compiler                                                      *
 * Copyright (C) 2005, 2006 Ronny Brandt (Ronny_Brandt@gmx.de).      *
 * All rights reserved.                                              *
 *                                                                   *
 * This work was done as a diploma project at the Chair for Software *
 * Technology, Dresden University Of Technology, Germany             *
 * (http://www-st.inf.tu-dresden.de).  It is understood that any     *
 * modification not identified as such is not covered by the         *
 * preceding statement.                                              *
 *                                                                   *
 * This work is free software; you can redistribute it and/or        *
 * modify it under the terms of the GNU Library General Public       *
 * License as published by the Free Software Foundation; either      *
 * version 2 of the License, or (at your option) any later version.  *
 *                                                                   *
 * This work is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of    *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU *
 * Library General Public License for more details.                  *
 *                                                                   *
 * You should have received a copy of the GNU Library General Public *
 * License along with this library; if not, write to the             *
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,      *
 * Boston, MA  02111-1307, USA.                                      *
 *                                                                   *
 * To submit a bug report, send a comment, or get the latest news on *
 * this project and other projects, please visit the web site:       *
 * http://www-st.inf.tu-dresden.de/ (Chair home page) or             *
 * http://www-st.inf.tu-dresden.de/ocl/ (project home page)          *
 * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * */
package tudresden.ocl20.core.lib;

import java.util.HashMap;
import java.util.Map;

public class UmlModelTypeManager extends ModelTypeManager {

	UmlOclFactory factory;
	
	private Map classCache = new HashMap();
	
	public UmlModelTypeManager(UmlOclFactory factory) {
		this.factory = factory;
	}
	
	@Override
	protected OclModelType findModelType(String pathname) {
		try {
			//int pos = pathname.indexOf("::");
			Class c = Class.forName(pathname.replaceAll("::","."));
			
			UmlModelType result = (UmlModelType)classCache.get(c);
			
			if (result == null) {
				result = new UmlModelType(pathname, c, factory);
				classCache.put(c, result);
			}
			return result;
		} catch (Exception e) {
			return null;
		}
	}

	@Override
	protected OclEnumType findEnumType(String pathname) {
		// TODO Auto-generated method stub
		return null;
	}

}
